;CTEXT an el-strippo CURVETXT without dynamic GRDARC preview - uses GRDARC
; in static mode, ENTMAKEs block with indefinite number of ATTRIBs, lots of
; other neat stuff.
; (c)1995 Terrible Software Inc. WDK "Drunken bums with broken hearts"
(defun C:CTEXT()
 (setq olderr *error*)
 (if (null debugg)
  (defun *error*(msg)
   (if (/= "Function Cancelled" msg)
    (princ (strcat "\nERROR: " msg " "))
   )
   (setq *error* olderr)
   (prin1)
  )
 )
 (if curvetxt_str
  (if (/= 'STR (type curvetxt_str))
   (setq curvetxt_str nil)
   (if (= "" curvetxt_str)
    (setq curvetxt_str nil)
   )
  )
 )
 (if curvetxt_str
  (progn
   (setq ans (getstring 1 (strcat "\nEnter string <" curvetxt_str ">: ")))
   (if (/= (xspace ans) "")
    (setq curvetxt_str ans)
   )
  )
  (progn
   (while (null curvetxt_str)
    (setq curvetxt_str (getstring 1 "\nEnter string: "))
    (if (= "" (xspace curvetxt_str))
     (progn
      (princ "\nString must have at least one visible character. ")
      (setq curvetxt_str nil)
     )
    )
   )
  )
 )
 (setq str curvetxt_str)
 (if curvetxt_hi
  (if (null (isposr curvetxt_hi))
   (setq curvetxt_hi (getvar "textsize"))
  )
  (setq curvetxt_hi (getvar "textsize"))
 )
 (setq styled (tblsearch "style" (getvar "textstyle"))
       stylhi (cdr (assoc 40 styled))
       stylob (cdr (assoc 50 styled))
       stylwf (cdr (assoc 41 styled))
 )
 (if (= 0.0 stylhi)
  (progn
   (initget 6)
   (if
    (setq ans
     (getreal (strcat "\nText height? <" (rtos curvetxt_hi 2 5) ">: "))
    )
    (setq curvetxt_hi ans)
   )
   (setq hi curvetxt_hi)
  )
  (setq hi stylhi)
 )
 (if (/= "" (setq str (xspace str)))
  (if (setq rp (getpoint "\nRadius point? "))
   (if (setq cp (getpoint "\nCenter of curved text? "))
    (progn
     (initget "Upside-down Right-side-up")
     (if curvetxt_upsidedown
      (if (/= "Right-side-up" (getkword "\nRight-side-up, <Upside-down>: "))
       (setq up nil)
       (setq up T)
      )
      (if (/= "Upside-down" (getkword "\nUpside-down, <Right-side-up>: "))
       (setq up T)
       (setq up nil)
      )
     )
     (setq curvetxt_upsidedown (null up))
     (if curvetxt_os
      (if
       (null
        (member curvetxt_os (list "A" "AA" "3A" "B" "BB" "3B" "C" "On" "Top"))
       )
       (setq curvetxt_os "C")
      )
      (setq curvetxt_os "C")
     )
     (initget "A AA 3A B BB 3B C On Top")
     (if
      (setq ans
       (getkword
        (strcat
         "\nInside of curved text goes where: 3A, AA, A, On, C, Top, B, BB, 3B, <"
         curvetxt_os
         ">: "
        )
       )
      )
      (setq curvetxt_os ans)
     ) 
     (cond
      ((= curvetxt_os "3A")(setq cp (polar cp (angle rp cp)(* 1.5 hi))))
      ((= curvetxt_os "AA")(setq cp (polar cp (angle rp cp) hi)))
      ((= curvetxt_os "A")(setq cp (polar cp (angle rp cp)(* 0.5 hi))))
      ((= curvetxt_os "C")(setq cp (polar cp (angle rp cp)(* -0.5 hi))))
      ((= curvetxt_os "Top")(setq cp (polar cp (angle rp cp)(* -1.0 hi))))
      ((= curvetxt_os "B")(setq cp (polar cp (angle rp cp)(* -1.5 hi))))
      ((= curvetxt_os "BB")(setq cp (polar cp (angle rp cp)(* -2.0 hi))))
      ((= curvetxt_os "3B")(setq cp (polar cp (angle rp cp)(* -2.5 hi))))
      (T nil)
     )
     (setq stlist (str2sl str) wlist nil)
     (foreach str stlist
      (setq wlist (cons (cons str (str2tb str)) wlist))
     )
     (if (> (setq rad (distance rp cp)) 0.0)
      (if (< (setq hd (whru2d wlist hi rad up)) pi)
       (progn
        (setq oo (whru2o wlist hi rad up) io (car oo) oo (cadr oo))
        (if (> (+ rad io) 0.0)
         (progn
          (setq bp (polar rp (- (angle rp cp) hd) rad)
                ep (polar rp (+ (angle rp cp) hd) rad)
                ibp (polar bp (angle rp bp) io)
                iep (polar ep (angle rp ep) io)
                obp (polar bp (angle rp bp) oo)
                oep (polar ep (angle rp ep) oo)
                bulge (/ (sin (* hd 0.5))(cos (* hd 0.5)))
          )
          (undraw
           (setq prevu
            (list
             (list ibp iep bulge)
             (list ibp obp 0)
             (list iep oep 0)
             (list obp oep bulge)
            )
           )
          )
          (initget "Yes No")
          (if (= "No" (getkword "\nPreview shown...Continue?  No, <Yes>: "))
           (progn
            (undraw prevu)
            (princ "\nCancelled. ")
           )
           (progn
            (undraw prevu)
            (if (null (drctxt str hi rp cp up))
             (princ "\nError generating curved text. ")
            )
           )
          )
         )
         (princ "\nError: radius <= zero at descender of text. ")
        )
       )
       (princ "\nError: text wraps around > 360 degrees. ")
      )
      (princ "\nError: zero radius. ")
     )
    )
   )
  )
 )
 (setq *error* olderr)
 (prin1)
)

;WHRU2D(WLIST HEIGHT RADIUS UPRIGHT) returns half-delta.  WLIST is a list of
; lists (WIDTH BOTTOM TOP).
(defun whru2d(wlist h r up / sum )
 (setq sum 0.0)
 (foreach sblist wlist
  (setq sum
   (+
    sum
    (atan
     (/
      (* h (cadr sblist) 0.5)
      (+ r (* h (if up (caddr sblist)(1- (cadddr sblist)))))
     )
    )
   )
  )
 )
 sum
)

;WHRU2O(WLIST H R UP) returns list of outside offset and inside offset.  No
; error checking
(defun whru2o(wlist h r up / oo io )
 (foreach sblist wlist
  (if io
   (setq io (min io (caddr sblist)))
   (setq io (caddr sblist))
  )
  (if oo
   (setq oo (max oo (cadddr sblist)))
   (setq oo (cadddr sblist))
  )
 )
 (if up
  (list (* h oo)(* h io))
  (list (* h (1+ io))(* h (- oo 1)))
 ) 
)

;DRCTXT(STR HIGH RAD CTR UP) returns T if it succeeds, or nil if it fails to
; create an INSERT of a CURVETXT block that spells out STR in curved text.
; I plan to use this a lot, so there's lots of parameter checking in it.
;(defun drctxt(str hi rp cp up / OK blkdat rad stlist wlist lasthd hd bg
;                                letrhd emlist extvec colnum edata to_rp 
;                                ename styled wf ob )
;)
(defun drctxt(str hi rp cp up)
 (setq OK T)
 (if (setq blkdat (tblsearch "block" "curvetxt"))
  (if (ct_is_bad blkdat)
   (progn
    (setq OK nil)
    (princ "\nThere is already a block called CURVETXT in your drawing.  However, it is not a")
    (princ "\ncorrect block definition for use with this program.  You might try renaming")
    (princ "\nthe CURVETXT block in your drawing; then this program will define a good")
    (princ "\nCURVETXT block, and work correctly.  The necessary ingredient for a good")
    (princ "\nCURVETXT block is one invisible attribute with tag VALUE and nothing else. ")
   )
  )
  (make_ct_block)
 )
 (if OK
  (if (and str hi rp cp)
   (if
    (and
     (is3dpt rp)
     (is3dpt cp)
     (= 'STR (type str))
     (isposr hi)
    )
    (if
     (and
      (/= "" (setq str (xspace str)))
      (> (setq rad (distance rp cp)) 0.0)
     )
     (progn
      ; parse string into string list and width list
      (setq stlist (str2sl str) 
            wlist nil
            emlist nil
            lasthd 0.0
            styled (tblsearch "style" (getvar "textstyle"))
      )
      (if (setq ob (assoc 50 styled))
       (setq ob (cdr ob))
       (setq ob 0.0)
      )
      (if (setq wf (assoc 41 styled))
       (setq wf (cdr wf))
       (setq wf 1.0)
      )
      (foreach str stlist
       (setq wlist (cons (cons str (str2tb str)) wlist))
      )
      (if (< (setq hd (whru2d wlist hi rad up)) pi)
       (progn
        (if up
         (setq bg (- (angle rp cp) hd))
         (setq bg (+ (angle rp cp) hd))
        )
        ; compile ENTMAKE list
        (foreach sblist wlist
         (setq letrhd
          (atan
           (/
            (* hi (cadr sblist) 0.5)
            (+ rad (* hi (if up (caddr sblist)(1- (cadddr sblist)))))
           )
          )
         )
         (if up
          (setq bg (+ bg letrhd lasthd))
          (setq bg (- bg letrhd lasthd))
         )
         (if (/= (xspace (car sblist)) "")
          (setq emlist
           (cons
            (list
             (car sblist) ; letter value
             (cadr sblist) ; letter width
             hi ; letter height
             (if up
              (polar rp bg rad) ; center point of letter
              (polar rp bg (+ rad hi))
             )
            )
            emlist
           )
          )
         )
         (setq lasthd letrhd)
        )
        ; make INSERT
        (setq extvec (trans (getvar "viewdir") 1 0)
              rp (trans rp 1 extvec) ; NOTE! now RP is in ECS
        )
        (setq colnum
         (cond
          ((= (getvar "cecolor") "BYLAYER") nil)
          ((= (getvar "cecolor") "BYBLOCK") 0)
          (T (atoi (getvar "cecolor")))
         )
        )
        (setq edata
         (list
          (cons 0 "INSERT")
          (cons 8 (getvar "clayer"))
          (cons 6 (getvar "celtype"))
          (cons 2 "CURVETXT")
          (cons 41 1.0)
          (cons 42 1.0)
          (cons 43 1.0)
          (cons 50 0.0)
          (cons 70 0)
          (cons 71 0)
          (cons 44 0)
          (cons 45 0)
          (cons 66 1)
          (cons 10 rp)
          (cons 210 extvec)
         )
        )
        (if colnum
         (setq edata
          (append edata (list (cons 62 colnum)))
         )
        )
        (if (entmake edata)
        ; make ATTRIBs
         (if
          (entmake
           (list
            (cons 0 "ATTRIB")
            (cons 1 str)
            (cons 2 "VALUE")
            (cons 6 "BYBLOCK")
            (cons 7 (getvar "textstyle"))
            (cons 8 "0")
            (cons 10 cp)
            (cons 40 hi)
            (cons 41 wf)
            (cons 51 ob)
            (cons 62 0)
            (cons 70 1)
            (cons 71 0)
            (cons 73 0)
            (cons 210 extvec)
           )
          )
          (progn
           (setq OK T)
           (foreach sblist emlist
            (setq cp (trans (cadddr sblist) 1 extvec) ; now RP, CP are in ECS
                  to_rp (angle cp rp) ; angle from CP towards RP in ECS
            )
            (if
             (null
              (entmake
               (list
                (cons 0 "ATTRIB")
                (cons 1 " ") ; The display doesn't update right if you ENTMAKE
                             ; ATTRIBs with values - they stay in the display
                             ; list even after the block has been erased. You
                             ; have to ENTMAKE blank ATTRIBs and fill them in
                             ; later using ENTMOD/ENTUPD instead.
                (cons 2 "LETTER")
                (cons 6 "BYBLOCK")
                (cons 7 (getvar "textstyle"))
                (cons 8 "0")
                (if up
                 (cons 10 (polar cp (- to_rp (* 0.5 pi))(* 0.5 (cadr sblist))))
                 (cons 10 (polar cp (+ to_rp (* 0.5 pi))(* 0.5 (cadr sblist))))
                )
                (cons 11 cp)
                (cons 40 hi)
                (cons 41 wf)
                (if up
                 (cons 50 (+ to_rp (* 0.5 pi)))
                 (cons 50 (- to_rp (* 0.5 pi)))
                )
                (cons 51 ob)
                (cons 62 0)
                (cons 70 0)
                (cons 71 0)
                (cons 72 1)
                (cons 73 0)
                (cons 210 extvec)
               )
              )
             )
             (setq OK nil)
            )
           )
           ; make ENDBLK
           (if OK
            (progn
             (setq edata
              (list
               (cons 0 "SEQEND")
               (cons 8 (getvar "clayer"))
               (cons 6 (getvar "celtype"))
              )
             )
             (if colnum
              (setq edata
               (append edata (list (cons 62 colnum)))
              )
             )
             (if (entmake edata)
              (progn ; Fill in visible attribute values using ENTMOD/ENTUPD
               (setq ename (entnext (entlast)) OK T)
               (foreach sblist emlist
                (setq ename (entnext ename) 
                      edata (entget ename)
                      OK (and
                          OK
                          (entmod
                           (subst (cons 1 (car sblist))(assoc 1 edata) edata)
                          )
                         )
                )
               )
               (if OK
                (if (entupd ename) ; return value of successful ENTUPD
                 T ; return value of whole function, means no problems
                 (progn
                  (entdel (entlast))
                  (bail "ENTUPD error filling in visible ATTRIBs.")
                 )
                )
                (progn
                 (entdel (entlast))
                 (bail "ENTMOD error filling in visible ATTRIBs.")
                )
               )
              )
              (bail "ENTMAKE error creating SEQEND.")
             )
            )
            (bail "ENTMAKE error creating visible ATTRIBs.")
           )
          )
          (bail "ENTMAKE error creating invisible ATTRIB.")
         )
         (bail "ENTMAKE error creating INSERT.")
        )
       )
       (bail "Characters wrap around > 360 degrees.")
      )
     ) ; end progn drawing curved text
     (bail "Invalid parameter value to DRCTXT.")
    )
    (bail "Invalid parameter type to DRCTXT.")
   )
   (bail "Invalid null parameter to DRCTXT.")
  )
 )
)

;BAIL(STR) prints error message, returns nil
(defun bail(str)
 (princ (strcat "\n" str " "))
 nil
)

;GRDARC(sglist color) GRDRAWs an arc, defined like a polyline arc by
; SGLIST (PT1, PT2, and BULGE), in color COLOR.
(defun grdarc(sglist color / pt1 pt2 bulge d h r p n nx a rp b grlist )
 (setq p (/ (getvar "viewsize")(cadr (getvar "screensize")) 2.0) ; 1/2 pixel
       pt1 (car sglist)
       pt2 (cadr sglist)
       bulge (caddr sglist)
 )
 (if (> (distance pt1 pt2)(* p 0.1))
  (if (equal bulge 0.0 1e-6)
   (progn ; draw a line
    (grvecs (list color pt1 pt2))
   )
   (progn ; draw an arc
    (setq d (distance pt1 pt2) ; chord length
          h (* 2.0 (atan bulge)) ; half-delta
          r (/ (* d (1+ (* bulge bulge))) 4.0 bulge) ; radius
          rp (polar pt1 (+ (angle pt1 pt2)(- (/ pi 2.0) h)) r) ; radius point
          r (abs r) ; note this lousy practice, redefining an existing var
    )
    (if (< p r)
     (progn
      (setq nx         ; number of segments
              (1+
               (fix (/ (abs h)(atan (/ (sqrt (- (* 2 r p)(* p p)))(- r p)))))
              )
            n (min nx 180)                       
            a (/ h n -0.5) ; delta per segment
            b (angle rp pt2)
            grlist nil
      )
      (if (> nx n)
       (princ (strcat "\n\007NX: " (rtos nx 2 10) "  N: " (itoa n) " "))
      )
      (while (> n 0)
       (setq grlist (cons (polar rp (+ b (* n a)) r) grlist))
       (setq grlist (cons (polar rp (+ b (* (setq n (1- n)) a)) r) grlist))
      )
      (grvecs (cons color grlist))
     )
    )
   )
  )
 )
)

;STR2TB(STR) returns a list (W B T) where W is the width of the box which
; surrounds a text entity in the current text style, of text height 1.0,
; whose value is the string STR; B is the Y coordinate of the bottom of the
; box, and T is the Y-coordinate of the top. The box (unlike the coordinates
; returned by TEXTBOX) includes any blank space at the beginning or end of
; the text entity.  (By using 1.0 as the text height, you don't have to use
; different cases for styles with fixed height and styles with zero height.)
(defun str2tb(str / tbox tbox2 tbox3 )
 (if (= 'STR (type str))
  (progn
   (setq tdat (list (cons 0 "TEXT")(cons 7 (getvar "textstyle"))(cons 40 1.0))
         tbox (textbox (cons (cons 1 str) tdat))
         tbox2 (textbox (cons (cons 1 "XX") tdat))
         tbox3 (textbox (cons (cons 1 (strcat "X" str "X")) tdat))
   )
   (list (- (caadr tbox3)(caadr tbox2))(cadar tbox)(cadadr tbox))
  )
 )
)

;STR2SL decomposes a string into a list of characters, taking into account
; substrings like "%%U", "%%124", and so on.
(defun str2sl(str / sl ts fc ul ol )
 (setq sl nil ts "" ul "" ol "")
 (while (/= "" str)
  (setq fc (substr str 1 1) str (substr str 2))
;  (showvals (list "STR" "SL" "FC" "UL" "OL" "TS"))
  (cond
   ((= ts "")
    (if (= fc "%")
     (setq ts "%")
     (setq sl (cons (strcat ul ol fc ol ul) sl))
    )
   )
   ((= ts "%")
    (if (= fc "%")
     (setq ts "%%")
     (setq sl
      (cons (strcat ul ol fc ol ul)(cons (strcat ul ol "%%%" ol ul) sl))
     )
    )
   )
   ((= ts "%%")
    (cond
     ((wcmatch fc "[%CDPcdp]")
      (setq ts "" sl (cons (strcat ul ol "%%" fc ol ul) sl))
     )
     ((wcmatch fc "#")
      (setq ts (strcat ts fc))
     )
     ((wcmatch fc "[Uu]")
      (setq ts "")
      (if (= "" ul)
       (setq ul "%%u")
       (setq ul "")
      )
     )
     ((wcmatch fc "[Oo]")
      (setq ts "")
      (if (= "" ol)
       (setq ol "%%o")
       (setq ol "")
      )
     )
     (T
      (setq ts "")
     )
    )
   )
   (T
    (if (wcmatch fc "#")
     (if (= 4 (strlen ts))
      (setq sl (cons (strcat ul ol ts fc ol ul) sl) ts "")
      (setq ts (strcat ts fc))
     )
     (if (= fc "%")
      (setq sl (cons (strcat ul ol ts ol ul) sl) ts "%")
      (setq sl
       (cons (strcat ul ol fc ol ul)(cons (strcat ul ol ts ol ul) sl))
            ts ""
      )
     )
    )
   )
  )
 )
 (if (and (/= (strlen ts) 2)(/= ts ""))
  (setq sl (cons ts sl))
 )
 (reverse sl)
)

;UNDRAW(UDLIST) undraws the thing in the undraw list UDLIST, a list made up
; of the first three parameters to GRDARC: PT1, PT2, BULGE
(defun undraw(udlist)
 (foreach sblist udlist
  (grdarc sblist 256)
 )
)

;XSPACE(str) returns a string stripped of its trailing and leading spaces
(defun xspace(str)
 (if (= 'STR (type str))
  (if (/= "" str)
   (progn
    (while (= " " (substr str 1 1))
     (setq str (substr str 2))
    )
    (if (/= "" str)
     (while (= " " (substr str (strlen str)))
      (setq str (substr str 1 (1- (strlen str))))
     )
    )
   )
  )
 )
 str
)

;IS3DPT(ARG) returns T if and only if ARG is a list of three numbers
(defun is3dpt(arg / OK )
 (setq OK nil)
 (if arg
  (if (= 'LIST (type arg))
   (if (= 3 (length arg))
    (progn
     (setq OK T)
     (foreach sub arg
      (if (null (numberp sub))
       (setq OK nil)
      )
     )
    )
   )
  )
 )
 OK
)

;ISPOSR(ARG) returns T if and only if ARG is a positive number
(defun isposr(arg)
 (if arg
  (if (numberp arg)
   (if (> arg 0.0)
    T
   )
  )
 )
)

;MAKE_CT_BLOCK
(defun make_ct_block()
 (entmake
  (list
   (cons 0 "BLOCK")
   (cons 2 "CURVETXT")
   (cons 70 66)
   (list 10 0.0 0.0 0.0)
  )
 )
 (entmake
  (list
   (cons 0 "ATTDEF")
   (cons 8 "0")
   (cons 6 "BYBLOCK")
   (cons 62 0)
   (cons 40 0.1)
   (cons 1 "")
   (cons 3 "Text value? ")
   (cons 2 "VALUE")
   (cons 70 1)
   (cons 73 0)
   (cons 50 0.0)
   (cons 41 1.0)
   (cons 51 0.0)
   (cons 7 "STANDARD")
   (cons 71 0)
   (cons 72 0)
   (cons 74 0)
   (list 10 0.0 0.0 0.0)
   (list 210 0.0 0.0 1.0)
  )
 )
 (entmake
  (list
   (cons 0 "ENDBLK")
  )
 )
)

;CT_IS_BAD
(defun ct_is_bad(blkdat / gotbot gottop gotlin bad ename edata etype )
 (setq gotatt nil ename (cdr (assoc -2 blkdat)))
 (while
  (and
   (null bad)
   ename
   (if ename
    (/= "ENDBLK" (setq etype (cdr (assoc 0 (setq edata (entget ename))))))
   )
  )
  (if gotatt
   (setq bad T)
   (if (= "ATTDEF" etype)
    (if (= "VALUE" (cdr (assoc 2 edata)))
     (if (= 1 (logand (cdr (assoc 70 edata)) 1))
      (setq gotatt T)
      (setq bad T)
     )
     (setq bad T)
    )
    (setq bad T)
   )
  )
  (setq ename (entnext ename))
 )
 (if (null gotatt)
  (setq bad T)
 )
 bad
)

;3P2RP(P1 P2 P3) returns the radius point of the arc defined by P1, P2 and P3
; if P1, P2 and P3 are all distinct and not co-linear. No error checking for
; parameters.
(defun 3p2rp(p1 p2 p3 / p12 p23 a12 a23 )
 (if
  (null
   (or
    (equal p1 p2)
    (equal p1 p3)
    (equal p2 p3)
    (= (setq a12 (angle p1 p2))(setq a23 (angle p2 p3)))
    (= (angle p2 p1) a23)
   )
  )
  (inters
   (setq p12 (polar p1 a12 (* 0.5 (distance p1 p2))))
   (polar p12 (+ (* 0.5 pi) a12) 1.0)
   (setq p23 (polar p2 a23 (* 0.5 (distance p2 p3))))
   (polar p23 (+ (* 0.5 pi) a23) 1.0)
   nil
  )
 )
)

;C:ZSUM()
(defun C:ZSUM()
 (setq sum 0.0)
 (princ (strcat "\nSUM: " (rtos sum 2 2) ". "))
 (prin1)
)

;C:CSUM
(defun C:CSUM()
 (if antext_point_2
  (setq last_ep antext_point_2)
 )
 (if last_ep
  (if (setq ans (getpoint last_ep "\nFirst point? <previous last point>: "))
   (setq p1 ans)
   (setq p1 last_ep)
  )
  (progn
   (initget 1)
   (setq p1 (getpoint "\nFirst point? "))
  )
 )
 (initget 1)
 (setq p2 (getpoint p1 "\nSecond point? "))
 (initget 1)
 (setq p3 (getpoint p2 "\nThird point? "))
 (if (setq rp (3p2rp p1 p2 p3))
  (progn
   (setq ar1 (angle rp p1)
         ar2 (angle rp p2)
         ar3 (angle rp p3)
         last_ep p3
         antext_point_2 p3
   )
   (if (> ar1 ar3)
    (if (or (> ar2 ar1)(< ar2 ar3))
     (setq delta (- (* 2.0 pi)(- ar1 ar3)))
     (setq delta (- ar1 ar3))
    )
    (if (or (> ar2 ar3)(< ar2 ar1))
     (setq delta (- (* 2.0 pi)(- ar3 ar1)))
     (setq delta (- ar3 ar1))
    )
   )
   (setq arc (* (distance rp p1) delta) sum (+ sum arc))
   (princ (strcat "\nSUM: " (rtos sum 2 2) ". "))
  )
  (princ "\nThree points are co-linear. ")
 )
 (prin1)
)

;C:LSUM
(defun C:LSUM()
 (if antext_point_2
  (setq last_ep antext_point_2)
 )
 (if last_ep
  (if (setq ans (getpoint last_ep "\nFirst point? <previous last point>: "))
   (setq p1 ans)
   (setq p1 last_ep)
  )
  (progn
   (initget 1)
   (setq p1 (getpoint "\nFirst point? "))
  )
 )
 (initget 1)
 (setq p2 (getpoint p1 "\nSecond point? ") last_ep p2 antext_point_2 p2)
 (setq sum (+ sum (distance p1 p2)))
 (princ (strcat "\nSUM: " (rtos sum 2 2) ". "))
 (prin1)
)

;C:CLEN prints the arc length of a curve you select by 3 points as curved
; text.
(defun C:CLEN()
 (if antext_point_2
  (setq last_ep antext_point_2)
 )
 (if curvetxt_hi
  (if (null (isposr curvetxt_hi))
   (setq curvetxt_hi (getvar "textsize"))
  )
  (setq curvetxt_hi (getvar "textsize"))
 )
 (setq styled (tblsearch "style" (getvar "textstyle"))
       stylhi (cdr (assoc 40 styled))
       stylob (cdr (assoc 50 styled))
       stylwf (cdr (assoc 41 styled))
 )
 (if (= 0.0 stylhi)
  (progn
   (initget 6)
   (if
    (setq ans
     (getreal (strcat "\nText height? <" (rtos curvetxt_hi 2 5) ">: "))
    )
    (setq curvetxt_hi ans)
   )
   (setq hi curvetxt_hi)
  )
  (setq hi stylhi)
 )
 (if last_ep
  (if (setq ans (getpoint last_ep "\nFirst point? <previous last point>: "))
   (setq p1 ans)
   (setq p1 last_ep)
  )
  (progn
   (initget 1)
   (setq p1 (getpoint "\nFirst point? "))
  )
 )
 (initget 1)
 (setq p2 (getpoint p1 "\nSecond point? "))
 (initget 1)
 (setq p3 (getpoint p2 "\nThird point? "))
 (if (setq rp (3p2rp p1 p2 p3))
  (progn
   (setq ar1 (angle rp p1)
         ar2 (angle rp p2)
         ar3 (angle rp p3)
         last_ep p3
         antext_point_2 p3
         rad (distance rp p1)
   )
   (if (> ar1 ar3)
    (if (or (> ar2 ar1)(< ar2 ar3))
     (setq delta (- (* 2.0 pi)(- ar1 ar3))
           cp (polar rp (+ ar1 (* 0.5 delta)) rad)
     )
     (setq delta (- ar1 ar3) cp (polar rp (- ar1 (* 0.5 delta)) rad))
    )
    (if (or (> ar2 ar3)(< ar2 ar1))
     (setq delta (- (* 2.0 pi)(- ar3 ar1))
           cp (polar rp (+ ar3 (* 0.5 delta)) rad)
     )
     (setq delta (- ar3 ar1) cp (polar rp (- ar3 (* 0.5 delta)) rad))
    )
   )
   (setq arc (* (distance rp p1) delta) str (rtos arc 2 2))
   (princ (strcat "\nARC: " (rtos arc 2 2) ". UP: "))
   (if
    (and
     (>= (setq rc (angle (trans rp 1 2)(trans cp 1 2))) 0.0)
     (<= rc pi)
    )
    (princ (setq up T))
    (princ (setq up nil))
   )
   (if curvetxt_os
    (if
     (null
      (member curvetxt_os (list "A" "AA" "3A" "B" "BB" "3B" "C" "On" "Top"))
     )
     (setq curvetxt_os "C")
    )
    (setq curvetxt_os "C")
   )
   (initget "A AA 3A B BB 3B C On Top")
   (if
    (setq ans
     (getkword
      (strcat
       "\nInside of curved text goes where: 3A, AA, A, On, C, Top, B, BB, 3B, <"
       curvetxt_os
       ">: "
      )
     )
    )
    (setq curvetxt_os ans)
   ) 
   (cond
    ((= curvetxt_os "3A")(setq cp (polar cp (angle rp cp)(* 1.5 hi))))
    ((= curvetxt_os "AA")(setq cp (polar cp (angle rp cp) hi)))
    ((= curvetxt_os "A")(setq cp (polar cp (angle rp cp)(* 0.5 hi))))
    ((= curvetxt_os "C")(setq cp (polar cp (angle rp cp)(* -0.5 hi))))
    ((= curvetxt_os "Top")(setq cp (polar cp (angle rp cp)(* -1.0 hi))))
    ((= curvetxt_os "B")(setq cp (polar cp (angle rp cp)(* -1.5 hi))))
    ((= curvetxt_os "BB")(setq cp (polar cp (angle rp cp)(* -2.0 hi))))
    ((= curvetxt_os "3B")(setq cp (polar cp (angle rp cp)(* -2.5 hi))))
    (T nil)
   )
   (setq stlist (str2sl str) wlist nil)
   (foreach str stlist
    (setq wlist (cons (cons str (str2tb str)) wlist))
   )
   (if (> (setq rad (distance rp cp)) 0.0)
    (if (< (setq hd (whru2d wlist hi rad up)) pi)
     (progn
      (setq oo (whru2o wlist hi rad up) io (car oo) oo (cadr oo))
      (if (> (+ rad io) 0.0)
       (progn
        (setq bp (polar rp (- (angle rp cp) hd) rad)
              ep (polar rp (+ (angle rp cp) hd) rad)
              ibp (polar bp (angle rp bp) io)
              iep (polar ep (angle rp ep) io)
              obp (polar bp (angle rp bp) oo)
              oep (polar ep (angle rp ep) oo)
              bulge (/ (sin (* hd 0.5))(cos (* hd 0.5)))
        )
        (undraw
         (setq prevu
          (list
           (list ibp iep bulge)
           (list ibp obp 0)
           (list iep oep 0)
           (list obp oep bulge)
          )
         )
        )
        (initget "Yes No")
        (if (= "No" (getkword "\nPreview shown...Continue?  No, <Yes>: "))
         (progn
          (undraw prevu)
          (princ "\nCancelled. ")
         )
         (progn
          (undraw prevu)
          (if (null (drctxt str hi rp cp up))
           (princ "\nError generating curved text. ")
          )
         )
        )
       )
       (princ "\nError: radius <= zero at descender of text. ")
      )
     )
     (princ "\nError: text wraps around > 360 degrees. ")
    )
    (princ "\nError: zero radius. ")
   )
  )
  (princ "\nThree points are co-linear. ")
 )
 (prin1)
)

